library schema_transform;

import 'dart:convert';

import 'package:fixnum/fixnum.dart';
import 'package:collection/wrappers.dart';

import '../proto/schema_v1_pb2.dart' as schema;
import '../common.dart' as mirrorfree;

part 'key.dart';
part 'entity.dart';

class KindRegistry<T> extends DelegatingMap<T,mirrorfree.KindDefinition> {
  KindRegistry(Map<T,mirrorfree.KindDefinition> defns): super(defns);

  @override
  operator [](T key) {
    var kind = super[key];
   if (kind == null)
     throw new mirrorfree.NoSuchKindError(key);
   return kind;
  }
}